分析

Attention!这道题的模数是\(1e8+7\)。

注意到循环同构会被认为是同一种方案,我们可以把顺时针旋转每个人的位置作为置换,容易发现这些置换一定会形成一个置换群,于是题目所求的所有合法的方案数便是这个置换群下等价类的数目,可以使用Burnside引理解决。

考虑如何求在置换“顺时针旋转\(x\)位置”下不动点的数目,可以发现这样的不动点的男女排列一定具有周期性,且\(gcd(n,x)\)是它的一个周期,这里可以自行画图理解一下。这样我们又再次简化了题目,我们现在只需考虑这一个周期了。

令\(d=gcd(n,x)\),首先进行如下的分类讨论:

  1. \(n \leq k\),这样不存在不合法的方案,返回\(2^d\)。

  2. \(n>k\)且\(d \leq k\),这样只要这个周期内不全是女生即是合法方案,返回\(2^d-1\)。

  3. \(n>k\)且\(d>k\),DP解决。

怎么DP?

\(f[i][j]\)表示不考虑循环的情况下,考虑到前\(i\)个人,最后\(j\)个人是女生的方案数。

\(g[i][j]\)表示不考虑循环的情况下,考虑到前\(i\)个人,保证第一个人是男生,最后\(j\)个人是女生的方案数。

显然有转移:

\[f[i][0]=\sum_{x=0}^{min(i-1,k)}f[i-1][x]
\]

\[f[i][j]=f[i-1][j-1]\ (j \neq 0)
\]

\(g[i][j]\)的转移与\(f[i][j]\)类似。

于是对于长度为\(i\)的区间,其合法方案数为\(\sum_{j=1}^{min(i,k)}f[i][j]-\sum_{j=k+1}^{min(i-1,2k)}g[i-j][0] \times (2k-j+1)\),这个可以直接预处理出来。

总结一下上面所提到的,在置换“顺时针旋转\(x\)位置”下的不动点,男女排列一定具有周期性,\(d=gcd(n,x)\)是其一个周期,我们只需要对这个区间进行讨论和计算,并统计到所有置换的不动点个数和中即可。

考虑到这样一个事实,\(\sum_{i=1}^{n}[gcd(i,n)=d]=\varphi(\frac{n}{d})\),所以可以直接枚举\(n\)的约数\(d\),然后计算\(d\)对答案的贡献。(这一步可有可无)

最后根据Burnside引理乘上一个\(n^{-1}\)。

代码

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cctype>
#include <algorithm>
#define rin(i,a,b) for(int i=(a);i<=(b);i++)
#define rec(i,a,b) for(int i=(a);i>=(b);i--)
#define trav(i,x) for(int i=head[(x)];i;i=e[i].nxt)
using std::cin;
using std::cout;
using std::endl;
typedef long long LL; inline int read(){
int x=0;char ch=getchar();
while(ch<'0'||ch>'9') ch=getchar();
while(ch>='0'&&ch<='9'){x=(x<<3)+(x<<1)+ch-'0';ch=getchar();}
return x;
} const int MAXN=2005;
const int MOD=1e8+7;
int n,k;
LL f[MAXN][MAXN],g[MAXN][MAXN],cnt[MAXN];
int prm[MAXN],phi[MAXN],pcnt;
bool vis[MAXN]; inline LL qpow(LL x,LL y){
LL ret=1,tt=x%MOD;
while(y){
if(y&1) ret=ret*tt%MOD;
tt=tt*tt%MOD;
y>>=1;
}
return ret;
} inline void pre_process1(){
phi[1]=1;
rin(i,2,n){
if(!vis[i]){
prm[++pcnt]=i;
phi[i]=i-1;
}
for(int j=1;j<=pcnt&&i*prm[j]<=n;j++){
vis[i*prm[j]]=1;
if(i%prm[j]==0){
phi[i*prm[j]]=phi[i]*prm[j];
break;
}
phi[i*prm[j]]=phi[i]*(prm[j]-1);
}
}
} inline void pre_process2(){
f[0][0]=f[1][0]=f[1][1]=g[1][0]=1;
rin(i,2,n){
f[i][0]=g[i][0]=0;
rin(j,0,std::min(i-1,k)){
f[i][0]+=f[i-1][j];
if(f[i][0]>=MOD) f[i][0]-=MOD;
}
rin(j,1,std::min(i,k)) f[i][j]=f[i-1][j-1];
rin(j,0,std::min(i-2,k)){
g[i][0]+=g[i-1][j];
if(g[i][0]>=MOD) g[i][0]-=MOD;
}
rin(j,1,std::min(i-1,k)) g[i][j]=g[i-1][j-1];
}
rin(i,1,n){
cnt[i]=0;
rin(j,0,std::min(i,k)){
cnt[i]+=f[i][j];
if(cnt[i]>=MOD) cnt[i]-=MOD;
}
rin(j,k+1,std::min(i-1,k<<1)){
cnt[i]-=g[i-j][0]*((k<<1)-j+1)%MOD;
if(cnt[i]<0) cnt[i]+=MOD;
}
}
} inline LL solve(int x){
if(x<=k){
if(k<n) return (qpow(2,x)-1+MOD)%MOD;
else return qpow(2,x);
}
else return cnt[x];
} int main(){
int T=read();
n=2000;
pre_process1();
while(T--){
n=read(),k=read();
pre_process2();
int lim=sqrt(n);
LL ans=0;
rin(i,1,lim){
if(n%i) continue;
ans=(ans+solve(i)*phi[n/i])%MOD;
if(i*i==n) continue;
ans=(ans+solve(n/i)*phi[i])%MOD;
}
printf("%lld\n",ans*qpow(n,MOD-2)%MOD);
}
return 0;
}

[BZOJ1547]周末晚会:Burnside引理+DP的更多相关文章

  1. BZOJ 1004 Cards(Burnside引理+DP)

    题目链接:http://61.187.179.132/JudgeOnline/problem.php?id=1004 题意:三种颜色的扑克牌各有Sr,Sb,Sg张.给出m种置换.两种染色方案在某种置换 ...

  2. [BZOJ 1004] [HNOI2008] Cards 【Burnside引理 + DP】

    题目链接:BZOJ - 1004 题目分析 首先,几个定义和定理引理: 群:G是一个集合,*是定义在这个集合上的一个运算. 如果满足以下性质,那么(G, *)是一个群. 1)封闭性,对于任意 a, b ...

  3. BZOJ 1004 Cards(Burnside引理+DP)

    因为有着色数的限制,故使用Burnside引理. 添加一个元置换(1,2,,,n)形成m+1种置换,对于每个置换求出循环节的个数, 每个循环节的长度. 则ans=sigma(f(i))/(m+1) % ...

  4. bzoj1004: [HNOI2008]Cards(burnside引理+DP)

    题目大意:3种颜色,每种染si个,有m个置换,求所有本质不同的染色方案数. 置换群的burnside引理,还有个Pólya过几天再看看... burnside引理:有m个置换k种颜色,所有本质不同的染 ...

  5. bzoj 1004 burnside 引理+DP

    对于burnside引理需要枚举染色,这道题属于burnside的一种简单求解的方法,就是polya,我们可以使每一种置换中的循环节中的元素的颜色都相同,那么这样的话就可以直接DP了,我们可以将m个置 ...

  6. UVA11540 Sultan's Chandelier Burnside 引理 + DP

    题目传送门 https://vjudge.net/problem/UVA-11540 https://uva.onlinejudge.org/index.php?option=com_onlineju ...

  7. [bzoj 1004][HNOI 2008]Cards(Burnside引理+DP)

    题目:http://www.lydsy.com/JudgeOnline/problem.php?id=1004 分析: 1.确定方向:肯定是组合数学问题,不是Polya就是Burnside,然后题目上 ...

  8. bzoj1547 周末晚会

    我们要求方案数,还是旋转同构的,想burnside,如果我们能计算出转i位不变的满足条件的数量,那么这道题我们就解决了. 考虑转i位时,设tmp=gcd(i,n),那么就共有tmp个循环节. 当tmp ...

  9. BZOJ 1004: [HNOI2008]Cards( 置换群 + burnside引理 + 背包dp + 乘法逆元 )

    题意保证了是一个置换群. 根据burnside引理, 答案为Σc(f) / (M+1). c(f)表示置换f的不动点数, 而题目限制了颜色的数量, 所以还得满足题目, 用背包dp来计算.dp(x,i, ...

随机推荐

  1. lograte切割tengine日志

    记录 /srv/logs/nginx/*log { create 0644 nobody nobody daily rotate 10 missingok notifempty compress sh ...

  2. Java第五周作业+总结

    实验三 String类的应用 实验目的 掌握类String类的使用: 学会使用JDK帮助文档: 实验内容 1.已知字符串:"this is a test of java".按要求执 ...

  3. dotnet sdk 的镜像tag 相关

    https://hub.docker.com/_/microsoft-dotnet-core-sdk/ 微软的dotnet sdk 的 tag 微软貌似改默认镜像 dockerhub 里面的tag与 ...

  4. Quartz-第三篇 quartz-misfire 错失,补偿执行

    1.问题:使用pauseJob()后,再使用resumeJob(). Job如果中间时间足够短,默认会将之前错失的次数执行回来.这个问题的原因是执行调度策略的问题,quartz框架默认会将错失的执行次 ...

  5. 状态压缩dp相关

    状态压缩dp 状态压缩是设计dp状态的一种方式. 当普通的dp状态维数很多(或者说维数与输入数据有关),但每一维总 量很少是,可以将多维状态压缩为一维来记录. 这种题目最明显的特征就是: 都存在某一给 ...

  6. 思维体操: HDU1049Climbing Worm

    Climbing Worm Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) To ...

  7. [CodePlus 2018 3 月赛] 博弈论与概率统计

    link 题意简述 小 $A$ 与小 $B$ 在玩游戏,已知小 $A$ 赢 $n$ 局,小 $B$ 赢 $m$ 局,没有平局情况,且赢加一分,输减一分,而若只有 $0$ 分仍输不扣分. 已知小 $A$ ...

  8. 基于Red5与ffmpeg实现rtmp处理NVR或摄像头的监控视频处理方案

    背景 各大监控视频平台厂商与外对接均是基于IE的OCX插件方式提供实时视频查看.历史视频回放与历史视频下载.在h5已大行其道的当下,基于IE的OCX插件方式已满足不了广大客户的实际需求,因此需要一个兼 ...

  9. redHat 安装mono 错误

    make[6]: * [do-install] Error 2 make[6]: Leaving directory /root/lindexi/mono-2.11.3/mcs/class/Syste ...

  10. Codeforces Round #427 (Div. 2) - C

    题目链接:http://codeforces.com/contest/835/problem/C 题意:在二维坐标里,有n个星星,m个询问,星星的最大亮度c.然后输入n个星星的坐标和初始亮度,对于每个 ...